package com.izouma.awesomeadmin.web;

import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CompanyAuthentication;
import com.izouma.awesomeadmin.service.CompanyAuthenticationService;
import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * controller类
 */
@Controller
@RequestMapping("/companyAuthentication")
@RequiresAuthentication
public class CompanyAuthenticationController {

    @Autowired
    private CompanyAuthenticationService companyAuthenticationService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CompanyAuthentication record) {
        List<CompanyAuthentication> pp = companyAuthenticationService.getCompanyAuthenticationList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getCompanyAuthentication", method = RequestMethod.GET)
    @ResponseBody
    public Result getCompanyAuthentication(@RequestParam(required = false, value = "id") String id) {
        CompanyAuthentication data = companyAuthenticationService.getCompanyAuthenticationById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CompanyAuthentication record) {
        CompanyAuthentication data = companyAuthenticationService.getCompanyAuthentication(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CompanyAuthentication record) {
        Map<String, Object> result = new HashMap<>();

        List<CompanyAuthentication> pp = companyAuthenticationService.getCompanyAuthenticationByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CompanyAuthentication record) {
        boolean num = companyAuthenticationService.createCompanyAuthentication(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCompanyAuthentication(CompanyAuthentication record) {
        boolean num = companyAuthenticationService.updateCompanyAuthentication(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCompanyAuthentication(@RequestParam(required = true, value = "id") String id) {

        boolean num = companyAuthenticationService.deleteCompanyAuthentication(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CompanyAuthentication record) throws Exception {

        List<CompanyAuthentication> companyAuthentications = companyAuthenticationService.getCompanyAuthenticationList(record);


        String sheetName = "company_authentication";
        String titleName = "企业认证数据表";
        String fileName = "企业认证表";
        int columnNumber = 19;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "用户ID", "用户名", "公司名", "注册时间", "工商注册号", "证件", "省", "城市", "国家", "状态", "电话", "姓名", "备注"};
        String[][] dataList = new String[companyAuthentications.size()][19];

        for (int i = 0; i < companyAuthentications.size(); i++) {

            dataList[i][0] = String.valueOf(companyAuthentications.get(i).getId());
            dataList[i][1] = String.valueOf(companyAuthentications.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(companyAuthentications.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(companyAuthentications.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(companyAuthentications.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(companyAuthentications.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(companyAuthentications.get(i).getUserId());
            dataList[i][7] = String.valueOf(companyAuthentications.get(i).getUserName());
            dataList[i][8] = String.valueOf(companyAuthentications.get(i).getCompany());
            dataList[i][9] = String.valueOf(companyAuthentications.get(i).getCompanyTime());
            dataList[i][10] = String.valueOf(companyAuthentications.get(i).getBusinessNo());
            dataList[i][11] = String.valueOf(companyAuthentications.get(i).getCertificate());
            dataList[i][12] = String.valueOf(companyAuthentications.get(i).getProvince());
            dataList[i][13] = String.valueOf(companyAuthentications.get(i).getCity());
            dataList[i][14] = String.valueOf(companyAuthentications.get(i).getCountry());
            dataList[i][15] = String.valueOf(companyAuthentications.get(i).getStatusFlag());
            dataList[i][16] = String.valueOf(companyAuthentications.get(i).getTelephone());
            dataList[i][17] = String.valueOf(companyAuthentications.get(i).getRealName());
            dataList[i][18] = String.valueOf(companyAuthentications.get(i).getRemark());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }

    /**
     * <p>审核通过。</p>
     */
    @RequestMapping(value = "/pass", method = RequestMethod.POST)
    @ResponseBody
    public Result pass(CompanyAuthentication record) {
        boolean num = companyAuthenticationService.pass(record);
        if (num) {
            return new Result(true, "通过");
        }
        return new Result(false, "异常");
    }

    /**
     * <p>审核失败。</p>
     */
    @RequestMapping(value = "/fail", method = RequestMethod.POST)
    @ResponseBody
    public Result fail(CompanyAuthentication record) {
        boolean num = companyAuthenticationService.fail(record);
        if (num) {
            return new Result(true, "成功");
        }
        return new Result(false, "异常");
    }
}

